// © 2020 ETH Zurich, Mechanics and Materials Lab
//
// This file is part of ae108.
//
// ae108 is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// ae108 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with ae108. If not, see <https://www.gnu.org/licenses/>.

#pragma once

#include "ae108/elements/AutomaticStiffnessMatrixTrait.h"

namespace ae108::elements {

/**
 * @brief Computes the stiffness matrix using numerical differentation of the
 * forces.
 */
template <class Element>
typename Element::StiffnessMatrix automatic_stiffness_matrix(
    const Element &element,
    const typename Element::NodalDisplacements &displacements,
    const typename Element::Time &time) {
  return AutomaticStiffnessMatrixTrait<Element>()(element, displacements, time);
}

} // namespace ae108::elements